'use strict';
'use strict';

const moment = require('moment');

module.exports = app => {
    const { STRING, INTEGER, DATE, DECIMAL, TEXT, ENUM } = app.Sequelize;

    const CourseUserCollection = app.classModel.define('course_old_user_collection', {
        id: {
            type: INTEGER,
            primaryKey: true,
            autoIncrement: true
        },
        user_uuid: STRING,
        institution_id: INTEGER,
        is_deleted: INTEGER,
        created_at: {
            type: DATE,
            allowNull: true,
            get() {
                const date = this.getDataValue('created_at');
                return date ? moment(date).format('YYYY-MM-DD HH:mm:ss') : undefined;
            },
        },
        updated_at: {
            type: DATE,
            allowNull: true,
            get() {
                const date = this.getDataValue('updated_at');
                return date ? moment(date).format('YYYY-MM-DD HH:mm:ss') : undefined;
            },
        },
    }, {
            timestamps: false,
            tableName: 'course_old_user_collection',
        });

    CourseUserCollection.one = async (data) => {
        const attributes = data.attributes ? data.attributes : {};
        const where = data.where ? data.where : {};
        return await CourseUserCollection.findOne({
            attributes: attributes,
            where: where,
        });
    }

    CourseUserCollection.all = async (data) => {
        const attributes = data.attributes ? data.attributes : {};
        const where = data.where ? data.where : {};
        const order = data.order ? data.order : [];
        return await CourseUserCollection.findAll({
            attributes: attributes,
            where: where,
            order,
        });
    }

    CourseUserCollection.list = async (data = {}) => {
        const limit = data.limit ? Number(data.limit) : 10;
        const page = data.page ? data.page : 1;
        const order = data.order ? data.order : [];
        const attributes = data.attributes ? data.attributes : {};
        const where = data.where ? data.where : {};
        const condition = {
            offset: (page - 1) * limit,
            limit,
            where: where,
            order: order,
            attributes: attributes,
        };
        const { count, rows } = await CourseUserCollection.findAndCountAll(condition);
        return { page, count, rows };
    }

    CourseUserCollection.add = async (data) => {
        try {
            //返回promise对象实力 instance 
            const res = await CourseUserCollection.create(data);
            //从promise 实例中中获得需要的id号，id 必须是自增长，而且必须主键，否则返回null
            return res.id;
        } catch (error) {
            throw (error);
        }
    }

    CourseUserCollection.edit = async (data) => {
        const where = data.where;
        const params = data.params;
        try {
            const res = await CourseUserCollection.update(params, { where: where })
            return res;
        } catch (error) {
            throw (error);
        }
    }

    return CourseUserCollection;

};